Open CASCADE Technology: OpenGl_PriorityList Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Member Functions | Protected Attributes
OpenGl_PriorityList Class Reference

`#include <OpenGl_PriorityList.hxx>`

## Public Member Functions
| OpenGl_PriorityList (const Standard_Integer theNbPriorities=11)
virtual | ~OpenGl_PriorityList ()
| Destructor. More...
void | Add (const OpenGl_Structure *theStructure, const Standard_Integer thePriority, Standard_Boolean isForChangePriority=Standard_False)
Standard_Integer | Remove (const OpenGl_Structure *theStructure, Standard_Boolean isForChangePriority=Standard_False)
| Remove structure and returns its priority, if the structure is not found, method returns negative value. More...
Standard_Integer | NbStructures () const
void | Render (const Handle< OpenGl_Workspace > &theWorkspace) const
Standard_Integer | NbPriorities () const
| Returns the number of available priority levels. More...
Standard_Boolean | Append (const OpenGl_PriorityList &theOther)
| Append priority list of acceptable type (with similar number of priorities or less). Returns Standard_False if the list can not be accepted. More...
const OpenGl_ArrayOfStructure & | ArrayOfStructures () const
| Returns array of OpenGL structures. More...
void | InvalidateBVHData ()
| Marks BVH tree for given priority list as dirty and marks primitive set for rebuild. More...

## Protected Member Functions
void | traverse (OpenGl_BVHTreeSelector &theSelector) const
| Traverses through BVH tree to determine which structures are in view volume. More...
void | renderAll (const Handle< OpenGl_Workspace > &theWorkspace) const
| Iterates through the hierarchical list of existing structures and renders them all. More...
void | renderTraverse (const Handle< OpenGl_Workspace > &theWorkspace) const
| Iterates through the hierarchical list of existing structures and renders only overlapping ones. More...

## Protected Attributes
OpenGl_ArrayOfStructure | myArray
Standard_Integer | myNbStructures
OpenGl_BVHClipPrimitiveSet | myBVHPrimitives
Standard_Boolean | myBVHIsLeftChildQueuedFirst
Standard_Boolean | myIsBVHPrimitivesNeedsReset

## Constructor & Destructor Documentation

OpenGl_PriorityList::OpenGl_PriorityList | ( | const Standard_Integer | theNbPriorities = `11` | ) |

virtual OpenGl_PriorityList::~OpenGl_PriorityList | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

void OpenGl_PriorityList::Add | ( | const OpenGl_Structure * | theStructure,
|  | const Standard_Integer | thePriority,
|  | Standard_Boolean | isForChangePriority = `Standard_False`
| ) |  |

Standard_Boolean OpenGl_PriorityList::Append | ( | const OpenGl_PriorityList & | theOther | ) |

Append priority list of acceptable type (with similar number of priorities or less). Returns Standard_False if the list can not be accepted.

const OpenGl_ArrayOfStructure& OpenGl_PriorityList::ArrayOfStructures | ( |  | ) | const
| inline

Returns array of OpenGL structures.

void OpenGl_PriorityList::InvalidateBVHData | ( |  | ) |

Marks BVH tree for given priority list as dirty and marks primitive set for rebuild.

Standard_Integer OpenGl_PriorityList::NbPriorities | ( |  | ) | const

Returns the number of available priority levels.

Standard_Integer OpenGl_PriorityList::NbStructures | ( |  | ) | const
| inline

Returns
  the number of structures

Standard_Integer OpenGl_PriorityList::Remove | ( | const OpenGl_Structure * | theStructure,
|  | Standard_Boolean | isForChangePriority = `Standard_False`
| ) |  |

Remove structure and returns its priority, if the structure is not found, method returns negative value.

void OpenGl_PriorityList::Render | ( | const Handle< OpenGl_Workspace > & | theWorkspace | ) | const

void OpenGl_PriorityList::renderAll | ( | const Handle< OpenGl_Workspace > & | theWorkspace | ) | const
| protected

Iterates through the hierarchical list of existing structures and renders them all.

void OpenGl_PriorityList::renderTraverse | ( | const Handle< OpenGl_Workspace > & | theWorkspace | ) | const
| protected

Iterates through the hierarchical list of existing structures and renders only overlapping ones.

void OpenGl_PriorityList::traverse | ( | OpenGl_BVHTreeSelector & | theSelector | ) | const
| protected

Traverses through BVH tree to determine which structures are in view volume.

## Field Documentation

OpenGl_ArrayOfStructure OpenGl_PriorityList::myArray
| protected

Standard_Boolean OpenGl_PriorityList::myBVHIsLeftChildQueuedFirst
| mutableprotected

OpenGl_BVHClipPrimitiveSet OpenGl_PriorityList::myBVHPrimitives
| mutableprotected

Standard_Boolean OpenGl_PriorityList::myIsBVHPrimitivesNeedsReset
| mutableprotected

Standard_Integer OpenGl_PriorityList::myNbStructures
| protected

The documentation for this class was generated from the following file:

- OpenGl_PriorityList.hxx